define([
		"dojo/_base/declare",
		"aps/Grid",
		"aps/DateTextBox",
		"dojo/dom-construct",
		"dojo/_base/array",
		"dojo/query"
], function(declare, Grid, DateTextBox, domConstruct, arr, query){
	return declare([Grid], {

		_createSearchPanel: function(root){
			var self = this,
				ul,
				node,
				frag = document.createDocumentFragment(),
				searchBoxes	 = query(".search-box", root);

			if(searchBoxes.length > 0)
				arr.forEach(searchBoxes, function(box){ domConstruct.destroy(box); });

			function submit(){
				self.set("_filters", []);
				query("input, select", self.toolbarNode).forEach(function(item){
					if(item.id && item.value)
						self._filters[item.id.split('-').pop()] = item.value;
				});
				self.selectionArray.splice(0, self.selectionArray.length);
				self._query(0, null, null, self.get("rowsPerPage"), 1);
			}

			arr.forEach(this.columns, function(column){
				if(column.filter){
					if(!node)
						node = query("form", domConstruct.create("div", { "class": "search-box", innerHTML: "<form></form>" }, frag))[0];

					if(!ul) ul = domConstruct.create("ul", {}, node);
					var li = query("span", domConstruct.create("li", {
							innerHTML: "<div><span>" + (column.filter.title ? column.filter.title : column.name) + "</span><span></span></div>" }, ul))[1];
					if(column.filter.options){
						var select = domConstruct.create("select", { id: self.id + "-search-select-" + column.field	}, li);
						domConstruct.create("option", {
							innerHTML: self.filterOptAllText,
							selected: "selected",
							value: ""
						}, select);
						arr.forEach(column.filter.options, function(option){
							var opt = domConstruct.create("option", {
								innerHTML: option.label,
								value: typeof option.value === "boolean" ? option.value + "()" : option.value
							}, select);

							if(opt.value == column.filter.value)
								opt.selected = "selected";
						});
					} else if (column.filter.type && column.filter.type.toLowerCase() === "date") {
						var date = new DateTextBox({
							id: this.id + "-search-date-" + column.field,
							value: column.filter.value ? (column.filter.value.start || column.filter.value) : undefined,
							autoSize: false
						});
						if(column.filter.value) {
							var constraints = {};
							if (column.filter.value.end){
								constraints.max = column.filter.value.end;
							}
							if (column.filter.value.start){
								constraints.min = column.filter.value.start;
							}
							date.set("constraints", constraints);
						}
						domConstruct.place(date.domNode, li);
					} else {
						domConstruct.create("input", {
							id: self.id + "-search-text-" + column.field,
							type: "text",
							value: column.filter.value || ""
						}, li);
					}
				}
			});

			if(node){
				query("input, select", node).on("keypress", function(e){
					if(e.keyCode == 13){
						submit();
						e.preventDefault();
					}
				});

				domConstruct.create("a", {
					"class": "s-btn sb-search",
					href: "javascript:void(0)",
					innerHTML: "<i><span>" + self.searchButtonText + "</span></i>",
					onclick: submit
				}, node);

				domConstruct.create("a", {
					"class": "s-btn sb-show-all",
					href: "javascript:void(0)",
					innerHTML: "<i><span>" + self.resetSearchButtonText + "</span></i>",
					onclick: function(){
						self.set({ "_filters": [] });
						self.selectionArray.splice(0, self.selectionArray.length);
						query("input, select", self.toolbarNode).forEach(function(item){
							item.value = "";
							if(item.selectedIndex) item.selectedIndex = 0;
						});
						self._query(0, null, null, self.get("rowsPerPage"));
					}
				}, node);
			}
			domConstruct.place(frag, root);
		},

		_setSortAttr: function(val){
			// fix empty "" descending for "reportedTime" attribute
			if (val.attribute && val.attribute === "reportedTime" && !val.descending && typeof val.descending === "string"){
				val.descending = true;
			}

			if(this.sort.attribute == val.attribute && this.sort.descending == val.descending) return;
			this._set("sort", { attribute: val.attribute || "", descending: val.descending || "" });
			this._putState({ sort: { attribute: val.attribute || "", descending: val.descending || "" } });
			if(this.get("_load"))
				this._query((this.get("currentPage")-1)*this.get("rowsPerPage"));
		}
	});
});